
#ifndef __EMETER_DLT645_H__
#define __EMETER_DLT645_H__
#include <stdint.h>

#define DLT645_MSG_RX_START_BODY    10
#define DLT645_MSG_RX_START_BODY_W  5
#define DLT645_MSG_TX_START_BODY    14
#define DLT645_MSG_TX_START_BODY_W  7
#define MAX_DLT645_MSG_BODY         66
#define UART_BAUD_RATE		9600 //2400

#define DLT645_PORT_SUPPORT_1			0
#define DLT645_PORT_SUPPORT_2			0
#define DLT645_PORT_SUPPORT_3			1
#define DLT645_PORT_SUPPORT_4			0
#define DLT645_PORT_SUPPORT_NUM		(DLT645_PORT_SUPPORT_1+DLT645_PORT_SUPPORT_2+DLT645_PORT_SUPPORT_3+DLT645_PORT_SUPPORT_4)		

#define DLT645_PORT1 (DLT645_PORT_SUPPORT_1-1)
#define DLT645_PORT2 (DLT645_PORT_SUPPORT_1+DLT645_PORT_SUPPORT_2-1)
#define DLT645_PORT3 (DLT645_PORT_SUPPORT_1+DLT645_PORT_SUPPORT_2+DLT645_PORT_SUPPORT_3-1)
#define DLT645_PORT4 (DLT645_PORT_SUPPORT_1+DLT645_PORT_SUPPORT_2+DLT645_PORT_SUPPORT_3+DLT645_PORT_SUPPORT_4-1)


#define INTER_CHAR_TIMEOUT		  2	// 2s
#define SEND_TIMEOUT						10 // 10s


typedef union
{
  uint8_t uint8[4 + 12 + MAX_DLT645_MSG_BODY];
  uint16_t uint16[(4 + 12 + MAX_DLT645_MSG_BODY)/2];
} serial_msg_t;

/* Incoming or outgoing serial message buffer */
typedef struct
{
    serial_msg_t buf;
    uint8_t ptr;
    uint8_t len;
    //uint8_t inter_char_timeout;
    //uint16_t baud_rate;			//96 *100
} serial_msg_buf_t;


struct uart_register_addr_s
{
	unsigned char volatile *pUCAxCTL0;
	unsigned char volatile *pUCAxCTL1;
	unsigned char volatile *pUCAxBR0;	
	unsigned char volatile *pUCAxBR1;	
	unsigned short volatile *pUCAxMCTL;
	unsigned char volatile *pUCAxSTAT;
	unsigned short const volatile *pUCAxRXBUF;
	unsigned short volatile *pUCAxTXBUF;
	unsigned short volatile *pUCAxIE;
	unsigned short volatile *pUCAxIFG;
	unsigned short volatile *pUCAxIV;
	//---------------------------
	unsigned char volatile *pPxDIR;		
	unsigned char volatile *pPxOUT;		
	unsigned char volatile *pPxSEL;		
	unsigned char PxTX;		
	unsigned char PxRX;		
};


void dlt645_callback(void);
void dlt645_init(void);


#endif

