/*******************************************************************************
*  emeter-main.c -
*
*  Copyright (C) 2011 Texas Instruments Incorporated - http://www.ti.com/ 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************/

/*! \file emeter-structs.h */

#include <stdint.h>
#include <stdlib.h>
#include <math.h>
#include <io.h>
#include "emeter-app.h"
#include "emeter-dlt645.h"
//-----------------------------------------------------------------------------------
// Call RTC library
#include "emeter-rtc-inter.h"

#define __infomem__     _Pragma("location=\"INFO\"")
__infomem__ __no_init const struct info_mem_s nv_parms;

struct rtc_interface user_rtc;		 
int temperature_C;


// p1.5 TA1.0
void init_1s_pulse_pin(void)
{
  P1OUT &= ~BIT5;
  P1DIR |= BIT5;
  P1SEL |= BIT5;
  
  PMAPPWD = 0x02D52;                        // Enable Write-access to modify port mapping registers
	P1MAP5 = PM_TA1_0;
  PMAPPWD = 0;                              // Disable Write-Access to modify port mapping registers
  
}

// demo code for using measurement and RTC library
void main(void)
{ 
	disable_watchdog();
//-----------------------------------------------------------------------------------
  // ϵͳʱӣIO 
  system_setup();
//-----------------------------------------------------------------------------------
	// dlt645 ͨѶʼ
  dlt645_init();  
//-----------------------------------------------------------------------------------
  // ʱ
  // ʹõǰóǧ
  user_rtc.year = 2012 - 2000;
  user_rtc.month = 1; 
	user_rtc.week = 0;
	user_rtc.day = 1;
	user_rtc.hour = 0;
	user_rtc.minute = 0;
	user_rtc.second = 0;
  // õǰʱ
  set_rtc_parameter(RTC_CURRENT_TIME, (int32_t)&user_rtc);  
  // ʼPWMܽ
  //set_rtc_parameter(RTC_1S_PULSE_PIN_INIT_CB, (int32_t)init_1s_pulse_pin);
  init_1s_pulse_pin();
  // RTC ⿪
  rtc_lib_open();
//---------------------------------main loop-----------------------------------------
  for (;;)
  {
    kick_watchdog();
    __enable_interrupt();
    dlt645_callback();
   
		// ȡǰʱ
		get_rtc_parameter(RTC_CURRENT_TIME, &user_rtc);	
		temperature_C = get_rtc_parameter(RTC_CURRENT_TEMP, 0);	
    
    // ȡǰRTC״̬
    if (get_rtc_parameter(RTC_ERROR_STATUS, 0))
    {
#if 1      
      set_rtc_parameter(RTC_ERROR_STATUS,0);
		  // ʱ
		  user_rtc.year = 2012 - 2000;
		  user_rtc.month = 1; 
			user_rtc.week = 0;
			user_rtc.day = 1;
			user_rtc.hour = 0;
			user_rtc.minute = 0;
			user_rtc.second = 0;
		  // õǰʱ
		  set_rtc_parameter(RTC_CURRENT_TIME, (int32_t)&user_rtc);   
#else

#endif      
    }
  }
//-----------------------------------------------------------------------------------  
}


