//******************************************************************************
//  MSP430F6736 RTC Calibration Library for China Smart Grid
// 	China MCU SAE Team.
//  Texas Instruments Inc.
//******************************* **********************************************
#ifndef __EMETER_RTC_H__
#define __EMETER_RTC_H__

#include "emeter-rtc-inter.h"

struct rtc_s {
	uint8_t chksum;
#if EN_THOUSAND_TIME	
	word_byte year;	
#else
	uint8_t year; 
#endif
	uint8_t month;
	uint8_t week;
	uint8_t day;	
	uint8_t hour;
	uint8_t minute;
	uint8_t second;	
};

//--------------------------------------------------------------------------------------------------------------------
extern struct rtc_s	lib_rtc_time;
//--------------------------------------------------------------------------------------------------------------------
extern void rtc_init(void);
extern void set_rtc_checksum(void);
extern int check_rtc_checksum(void);
extern void set_time_internal(struct rtc_interface *ptr_rtc);
extern void get_time_internal(struct rtc_interface *ptr_rtc);
//--------------------------------------------------------------------------------------------------------------------



#endif

